#!/bin/bash

#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  #
#	  Última actualización: 28-Jul-2011    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	        #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.    #
#	    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.	    #
#	    #
############################################################################# 
# autor: Charles Escobar
# sitio: http://www.gradio.net
# fecha: 12/11/2019
# ver: RC 0.23
# Script para lanzar G-Radio

#Desconecta loopback
pactl unload-module module-loopback
##
##Verifica la existencia de la carpeta botonera que puede crear un error de acceso en gambas
test ! -d $HOME/.gradio/data/panel/botonera/ && mkdir $HOME/.gradio/data/panel/botonera
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX1/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX1
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX2/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX2
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX3/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX3
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX4/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX4
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX5/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX5
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX6/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX6
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX7/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX7
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX8/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX8
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX9/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX9
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX10/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX10
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX11/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX11
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FX12/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FX12
test ! -d $HOME/.gradio/data/panel/botonera/fxxs/FXTV/ && mkdir $HOME/.gradio/data/panel/botonera/fxxs/FXTV

a=`ps uax|grep -v grep|grep GMain.gambas`
if [ "$a" = "" ]; then 
	echo "se lanza reset"
	$HOME/.gradio/bin/detener.sh
	$HOME/.gradio/bin/reset.sh
sleep 1
if [[ ! -f $HOME/.gradio/bin/GMain.gambas ]]; then
	mascara=`ls $HOME/.gradio/bin/mascara|head -n 1`
	ln -s $HOME/.gradio/bin/mascara/"$mascara" $HOME/.gradio/bin/GMain.gambas
fi
$HOME/.gradio/bin/GMain.gambas &
else
	accion=`/usr/bin/zenity --title="GRadio aparece como abierto, por favor revise sus pantallas" --width=400 --height=200 \
                         --text="GRadio aparece como abierto, por favor revise sus ventanas" \
                         --list --column="Seleccione" --column="Ejecutar" \
                         --radiolist TRUE "Si se ha estado ejecutando no hacer nada" FALSE "Parece colgado, resetear el programa" `

	if [ $? -eq 0 ]; then
		if [[ $accion = "Parece colgado, resetear el programa" ]]; then
		killall -9 GMain.gambas 
		killall -9 gbr3
		echo "se resetea la interfaz y lanza reset"
		$HOME/.gradio/bin/detener.sh
		$HOME/.gradio/bin/reset.sh 
		sleep 1
		$HOME/.gradio/bin/GMain.gambas &
		fi
	else
	exit 0
	fi
fi
